// Models.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
import Alamofire

protocol JSONEncodable {
    func encodeToJSON() -> Any
}

public enum ErrorResponse: Error {
    case error(Int, Data?, URLResponse?, Error)
}

public enum ParameterError: Error {
    case outOfRange
    case IO
    case emptyRequest
    case fileSizeNotAvailable
    case invalidName
    case invalidVersion
}

public enum DownloadException: Error {
    case responseDataMissing
    case responseFailed
    case requestMissing
    case requestMissingPath
    case requestMissingURL
}

public enum DecodableRequestBuilderError: Error {
    case emptyDataResponse
    case nilHTTPResponse
    case unsuccessfulHTTPStatusCode
    case jsonDecoding(DecodingError)
    case generalError(Error)
}

open class Response<T> {
    public let statusCode: Int
    public let header: [String: String]
    public let body: T

    public init(statusCode: Int, header: [String: String], body: T) {
        self.statusCode = statusCode
        self.header = header
        self.body = body
    }

    public convenience init(response: HTTPURLResponse, body: T) {
        let rawHeader = response.allHeaderFields
        var header = [String: String]()
        for (key, value) in rawHeader {
            if let key = key.base as? String, let value = value as? String {
                header[key] = value
            }
        }
        self.init(statusCode: response.statusCode, header: header, body: body)
    }
}

public class RequestTask {
    private var lock = NSRecursiveLock()
    private var request: Request?

    internal func set(request: Request) {
        lock.lock()
        defer { lock.unlock() }
        self.request = request
    }

    public func cancel() {
        lock.lock()
        defer { lock.unlock() }
        request?.cancel()
        request = nil
    }

    public var state: Request.State {
        request?.state ?? .initialized
    }

    public var uploadProgress: Progress? {
        request?.uploadProgress
    }

    public var downloadProgress: Progress? {
        request?.downloadProgress
    }
}